"""
Carlos J Corrada Bravo
Este programa calcula el promedio de tiempo de ejecucion de cuatro algoritmos de ordenamiento
La variable maxValor define el valor maximo de los elementos de la lista
La variable largoLista define el largo de las listas a ordenar
<<<<<<< HEAD
La variable veces define las veces que se va a hacer el ordenamiento
=======
La variable veces define las veces que se va a hacer el ordenamiento
>>>>>>> a2416a1f1584bddc699e3c6dfe5efdd25f2ac172
Al final se imprimen los promedios de cada algortimo
"""
from random import randint
import time
from merge import merge
from heap import heap

# Python program for implementation of MergeSort

# Merges two subarrays of arr[].
# First subarray is arr[l..m]
# Second subarray is arr[m+1..r]

def mergeSort(lista, l, r):
	if l < r:

	# Same as (l+r)//2, but avoids overflow for
	# large l and h
	m = l+(r-l)//2

	# Sort first and second halves
	mergeSort(lista, l, m)
	mergeSort(lista, m+1, r)
	merge(lista, l, m, r)

def heapSort(lista):

	n = len(lista)
	h1 = (n // 2) - 1
	for i in range(h1, -1, -1):
		heapify(lista, n, i)

	for i in range(h1, -1, -1):
		lista[i], lista[0] = lista[0], lista[i]
		heapify(lista, i, 0)

	return lista

def quickSort(lista):
	#definan el algoritmo de ordenamiento quicksort
	return lista

def shellSort(lista):
	#definan el algoritmo de ordenamiento shellsort
	return lista

maxValor=1000 	#define el valor maximo de los elementos de la lista
largoLista=1000 	#define el largo de las listas a ordenar
veces=100    		#define las veces que se va a hacer el ordenamiento

acumulaMerge=0 	#variable para acumular el tiempo de ejecucion del mergesort
acumulaHeap=0 	#variable para acumular el tiempo de ejecucion del heapsort
acumulaQuick=0 	#variable para acumular el tiempo de ejecucion del quicksort
acumulaShell=0 	#variable para acumular el tiempo de ejecucion del shellsort

for i in range(veces):
	mergelista = [randint(0,maxValor) for r in range(largoLista)] #creamos una lista con valores al azar
	heaplista=list(mergelista)
	quicklista=list(mergelista)
	searchlista=list(mergelista)

	t1 = time.process_time()					#tomamos el tiempo inicial
	mergeSort(mergelista,0,len(mergelista)-1) 	#ejecutamos el algoritmo mergeSort
	acumulaMerge+=time.process_time() - t1		#acumulamos el tiempo de ejecucion
	print(mergelista)							#desplegamos la lista

	t1 = time.process_time()				#tomamos el tiempo inicial
	heapSort(heaplista)					    #ejecutamos el algoritmo heapSort
	acumulaHeap+=time.process_time() - t1 	#acumulamos el tiempo de ejecucion
	print(heaplista)						#desplegamos la lista

	t1 = time.process_time()				#tomamos el tiempo inicial
	quickSort(quicklista)					#ejecutamos el algoritmo quickSort
	acumulaQuick+=time.process_time() - t1	#acumulamos el tiempo de ejecucion
	print(quicklista)						#desplegamos la lista

	t1 = time.process_time()				#tomamos el tiempo inicial
	shellSort(searchlista)					#ejecutamos el algoritmo shellSort
	acumulaShell+=time.process_time() - t1	#acumulamos el tiempo de ejecucion
	print(searchlista)						#desplegamos la lista

#imprimos los resultados
print ("Promedio de tiempo de ejecucion de "+ str(veces) +" listas de largo " + str(largoLista))
print ("MergeSort " + str(acumulaMerge/veces) + " segundos")
print ("HeapSort " + str(acumulaHeap/veces) + " segundos")
print ("QuickSort " + str(acumulaQuick/veces) + " segundos")
print ("ShellSort " + str(acumulaShell/veces) + " segundos")
